/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.47 by adcroft, Tue Nov 25 14:57:45 2003 UTC revision 1.59 by edhill, Sun Jan 11 17:02:47 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
86            
# Line 471  MODS= Line 478  MODS=
478  TOOLSDIR=  TOOLSDIR=
479  SOURCEDIRS=  SOURCEDIRS=
480  INCLUDEDIRS=  INCLUDEDIRS=
481  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
482    
483  PWD=`pwd`  PWD=`pwd`
484  MAKE=make  MAKE=make
# Line 586  for ac_option ; do Line 593  for ac_option ; do
593          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
594              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
595                    
596          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
597              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
598          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
599              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 888  if test "x$HAVE_CLOC" != x ; then Line 895  if test "x$HAVE_CLOC" != x ; then
895  else  else
896      echo "no"      echo "no"
897  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
898  rm -f genmake_t*  rm -f genmake_t*
899    
900    
# Line 961  if test -r $ROOTDIR"/eesupp/src/Makefile Line 962  if test -r $ROOTDIR"/eesupp/src/Makefile
962      fi      fi
963  fi  fi
964    
965    #same for exch2
966    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
967        echo "  Making source files in exch2 from  templates"
968        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
969        RETVAL=$?
970        if test "x${RETVAL}" = x0 ; then
971            rm -f make_exch2.errors
972        else
973            echo "Error: problem encountered while building source files in exch2:"
974            cat make_exch2.errors
975            exit 1
976        fi
977    fi
978    
979  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
980  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
981      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 1178  for i in $PACKAGES ; do Line 1193  for i in $PACKAGES ; do
1193  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1194      case $i in      case $i in
1195          aim_v23)          aim_v23)
             DEFINES="$DEFINES -DALLOW_AIM"  
1196              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1197              echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
1198              ;;              ;;
1199      esac      esac
1200  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
# Line 1189  done Line 1203  done
1203    
1204  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1205  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1206  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1207      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1208  fi  fi
1209  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1210      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1211      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1212          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1213          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1214          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1215      else              exit 1
1216          SOURCEDIRS="$SOURCEDIRS $adr"          else
1217      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1218      adr="$ROOTDIR/$d/inc"          fi
1219      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1220          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1221          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1222          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1223      else              exit 1
1224          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1225      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1226  done          fi
1227        done
1228    fi
1229    
1230  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1231  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1232  CPP_OPTIONS=  CPP_OPTIONS=
1233    CPP_EEOPTIONS=
1234  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1235    names=`ls -1 "$ROOTDIR/pkg"`
1236  for i in $spaths ; do  for i in $spaths ; do
1237      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1238      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1239          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1240          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1241          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1242            for n in $names ; do
1243                test_for_package_in_cpp_options $CPP_OPTIONS $n
1244            done
1245        fi
1246        try="$i/CPP_EEOPTIONS.h"
1247        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1248            echo "    found CPP_EEOPTIONS=\"$try\""
1249            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1250    #**** not yet enabled ****
1251    #        test_for_mpi_in_cpp_eeoptions $try
1252    #**** not yet enabled ****
1253            CPP_EEOPTIONS="$try"
1254      fi      fi
1255  done  done
1256  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1257      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1258      exit 1      exit 1
1259  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1260    
1261  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1262  #  compiler.  #  compiler.
# Line 1347  EXE_FTL=$EXECUTABLE"_ftl" Line 1370  EXE_FTL=$EXECUTABLE"_ftl"
1370  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1371    
1372  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1373    #
1374    # OPTFILE="$OPTFILE"
1375  #  #
1376  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1377  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1383  EXE_SVD     = ${EXE_SVD} Line 1408  EXE_SVD     = ${EXE_SVD}
1408  ENABLED_PACKAGES = ${ENABLED_PACKAGES}  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1409  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1410    
1411    # These files are created by Makefile
1412    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1413    
1414  EOF  EOF
1415    
1416  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1447  cat >>$MAKEFILE <<EOF Line 1475  cat >>$MAKEFILE <<EOF
1475  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1476    
1477  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1478  \$(EXECUTABLE): links \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1479          @echo Creating \$@ ...          @echo Creating \$@ ...
1480          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1481  depend:  depend:
# Line 1455  depend: Line 1483  depend:
1483          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1484          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1485    
1486  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) ${PACKAGES_DOT_H} AD_CONFIG.h  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1487    
1488  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1489    
# Line 1468  clean: Line 1496  clean:
1496  Clean:  Clean:
1497          @make clean          @make clean
1498          @make cleanlinks          @make cleanlinks
1499          -rm -f ${PACKAGES_DOT_H} AD_CONFIG.h          -rm -f \$(SPECIAL_FILES)
1500          -rm -f Makefile.bak genmake_state genmake_*optfile genmake_warnings make.log          -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1501  CLEAN:  CLEAN:
1502          @make Clean          @make Clean
1503          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1483  makefile: Line 1511  makefile:
1511  cleanlinks:  cleanlinks:
1512          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1513    
1514  # Special targets  # Special targets ($SPECIAL_FILES) which are create by make
1515  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
1516          @echo Creating \$@ ...          @echo Creating \$@ ...
1517          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1518  AD_CONFIG.h:  AD_CONFIG.h:
1519          @echo Creating \$@ ...          @echo Creating \$@ ...
1520          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1521    FC_NAMEMANGLE.h:
1522            @echo Creating \$@ ...
1523            echo "$FC_NAMEMANGLE" > \$@
1524    
1525  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1526  .F.f:  .F.f:
# Line 1549  adall: ad_taf Line 1580  adall: ad_taf
1580  adtaf: ad_taf_output.f  adtaf: ad_taf_output.f
1581  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1582    
1583  ad_input_code.f: links \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1584          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1585          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1586          -rm -f ad_config.template          -rm -f ad_config.template
# Line 1581  ftlall: ftl_taf Line 1612  ftlall: ftl_taf
1612  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.f
1613  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1614    
1615  ftl_input_code.f: links \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1616          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1617          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1618          -rm -f ftl_config.template          -rm -f ftl_config.template

Legend:
Removed from v.1.47  
changed lines
  Added in v.1.59

  ViewVC Help
Powered by ViewVC 1.1.22